Unit adh0e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, AFH0E_p;

procedure adh0e(var A :Array of Extended; var D1 :Extended;
                var D2 :Integer; var S :Array of Extended;
                var N :Integer); 
implementation

procedure adh0e(var A :Array of Extended; var D1 :Extended;
                var D2 :Integer; var S :Array of Extended;
                var N :Integer);
var
I :Integer;
label
_1,_2,_3,_4;
begin
AFH0E(A,S,N);
for I:=1 to N do
 begin
_1:
  S[I-1] := 1.e0/S[I-1];
 end;
D1 := 1.e0;
D2 := 0;
for I:=1 to N do
 begin
  D1 := D1*S[I-1];
_2:
  if ( Abs(D1) < 1.e0 ) 
   then goto _3;
  D1 := D1*0.0625e0;
  D2 := D2+4;
  goto _2;
_3:
  if ( Abs(D1) >= 0.0625e0 ) 
   then goto _4;
  D1 := D1*16.e0;
  D2 := D2-4;
  goto _3;
_4:
 end;
end;

end.
